searchData={"items":[{"type":"behaviour","title":"QuickFactory","doc":"","ref":"QuickFactory.html"},{"type":"callback","title":"QuickFactory.build/1","doc":"Callback that returns a map with valid defaults for the schema.","ref":"QuickFactory.html#c:build/1"},{"type":"function","title":"QuickFactory.build/3","doc":"Builds a schema given the factory `module` and an optional\nlist/map of `params`.","ref":"QuickFactory.html#build/3"},{"type":"function","title":"QuickFactory.build_invalid_params/1","doc":"","ref":"QuickFactory.html#build_invalid_params/1"},{"type":"function","title":"QuickFactory.build_many_params/4","doc":"Builds many parameters for a schema `changeset/2` function given the factory\n`module` and an optional list/map of `params`.","ref":"QuickFactory.html#build_many_params/4"},{"type":"type","title":"QuickFactory.build_opts/0","doc":"","ref":"QuickFactory.html#t:build_opts/0"},{"type":"function","title":"QuickFactory.build_params/3","doc":"Builds the parameters for a schema `changeset/2` function given the factory\n`module` and an optional list/map of `params`.","ref":"QuickFactory.html#build_params/3"},{"type":"callback","title":"QuickFactory.build_struct/1","doc":"Callback that returns a struct with valid defaults for the schema.","ref":"QuickFactory.html#c:build_struct/1"},{"type":"callback","title":"QuickFactory.changeset/0","doc":"Callback that returns which changeset function to use.","ref":"QuickFactory.html#c:changeset/0"},{"type":"function","title":"QuickFactory.cleanup/2","doc":"Removes all the instances of a schema from the database given its factory\n`module`.","ref":"QuickFactory.html#cleanup/2"},{"type":"function","title":"QuickFactory.insert!/3","doc":"Inserts a schema given the factory `module` and an optional list/map of\n`params`. Fails on error.","ref":"QuickFactory.html#insert!/3"},{"type":"function","title":"QuickFactory.insert_many!/4","doc":"Insert as many as `count` schemas given the factory `module` and an optional\nlist/map of `params`.","ref":"QuickFactory.html#insert_many!/4"},{"type":"callback","title":"QuickFactory.repo/0","doc":"Callback that returns the schema's repo module.","ref":"QuickFactory.html#c:repo/0"},{"type":"callback","title":"QuickFactory.schema/0","doc":"Callback that returns the schema module.","ref":"QuickFactory.html#c:schema/0"},{"type":"module","title":"QuickFactory.Counters","doc":"This is a counter module that wraps :counters","ref":"QuickFactory.Counters.html"},{"type":"module","title":"Setup - QuickFactory.Counters","doc":"We can use this in our application by calling `QuickFactory.Counters.start()`\ninside our `test/test_helper.exs` file.","ref":"QuickFactory.Counters.html#module-setup"},{"type":"module","title":"Using Counters - QuickFactory.Counters","doc":"We can then use this module to add unique integers to each field, each value\nwill only be used once provided we continue to call `QuickFactory.Counters.next`\n\n```elixir\nQuickFactory.Counters.next(\"my_schema_field\")\n```","ref":"QuickFactory.Counters.html#module-using-counters"},{"type":"function","title":"QuickFactory.Counters.get/1","doc":"Gets the counter for a specific key","ref":"QuickFactory.Counters.html#get/1"},{"type":"function","title":"Example - QuickFactory.Counters.get/1","doc":"iex> key = Enum.random(1..10_000_000)\n    iex> QuickFactory.Counters.increment(key)\n    :ok\n    iex> QuickFactory.Counters.get(key)\n    1","ref":"QuickFactory.Counters.html#get/1-example"},{"type":"function","title":"QuickFactory.Counters.inc/1","doc":"","ref":"QuickFactory.Counters.html#inc/1"},{"type":"function","title":"QuickFactory.Counters.increment/1","doc":"Increments the counter for a specific key","ref":"QuickFactory.Counters.html#increment/1"},{"type":"function","title":"Example - QuickFactory.Counters.increment/1","doc":"iex> key = Enum.random(1..10_000_000)\n    iex> QuickFactory.Counters.increment(key)\n    :ok\n    iex> QuickFactory.Counters.get(key)\n    1","ref":"QuickFactory.Counters.html#increment/1-example"},{"type":"function","title":"QuickFactory.Counters.next/1","doc":"Increments and gets the current value for a specific key","ref":"QuickFactory.Counters.html#next/1"},{"type":"function","title":"Example - QuickFactory.Counters.next/1","doc":"iex> key = Enum.random(1..10_000_000)\n    iex> QuickFactory.Counters.next(key)\n    0\n    iex> QuickFactory.Counters.next(key)\n    1\n    iex> QuickFactory.Counters.next(key)\n    2","ref":"QuickFactory.Counters.html#next/1-example"},{"type":"function","title":"QuickFactory.Counters.put/2","doc":"Puts the counter for a specific key","ref":"QuickFactory.Counters.html#put/2"},{"type":"function","title":"Example - QuickFactory.Counters.put/2","doc":"iex> key = Enum.random(1..10_000_000)\n    iex> QuickFactory.Counters.increment(key)\n    :ok\n    iex> QuickFactory.Counters.put(key, 1234)\n    :ok\n    iex> QuickFactory.Counters.get(key)\n    1234","ref":"QuickFactory.Counters.html#put/2-example"},{"type":"function","title":"QuickFactory.Counters.reset/0","doc":"","ref":"QuickFactory.Counters.html#reset/0"},{"type":"function","title":"QuickFactory.Counters.start/0","doc":"This starts the Counters, you need to call this before calling any of the other\nfunctions in this module. Most commonly this will go in your `test/test_helper.exs` file","ref":"QuickFactory.Counters.html#start/0"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}